package probalign;

import java.awt.*;

import javax.swing.*;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

/**
 * <p>Title: PROBALIGN</p>
 *
 * <p>Description:
 *   Dialog box for handling alignment viewing options
 * </p>
 *
 *
 *
 *  @author Satish Chikkagoudar
 *  @version Beta 1.3
 */
public class AlignmentChooser extends JDialog {

    JPanel panel1 = new JPanel();
    BorderLayout borderLayout1 = new BorderLayout();
    FlowLayout flowLayout1 = new FlowLayout();
    ButtonGroup buttonGroup1 = new ButtonGroup();
    Box box1 = Box.createVerticalBox();
    Box box2 = Box.createHorizontalBox();
    JRadioButton selectcolumns = new JRadioButton();
    JRadioButton entirealignment = new JRadioButton();
    JTextField jTextField1 = new JTextField();
    Box box4 = Box.createHorizontalBox();
    JButton jButton1 = new JButton();
    JButton jButton2 = new JButton();
    Box box5 = Box.createHorizontalBox();
    Component component2 = Box.createGlue();
    Component component4 = Box.createGlue();
    public AlignmentChooser(Frame owner, String title, boolean modal) {
        super(owner, title, modal);
        try {

            setDefaultCloseOperation(DISPOSE_ON_CLOSE);
            jbInit();
            pack();
        } catch (Exception exception) {
            exception.printStackTrace();
        }
    }

    public AlignmentChooser() {
        this(new Frame(), "AlignmentChooser", false);
    }

    private void jbInit() throws Exception {
        component2 = Box.createGlue();
        box2 = Box.createHorizontalBox();
        panel1.setLayout(borderLayout1);

        this.setMaximumSize(new Dimension(400,110));
        this.setMinimumSize(new Dimension(400,110));
        this.setPreferredSize(new Dimension(400,110));
        selectcolumns.setHorizontalAlignment(SwingConstants.LEFT);
        selectcolumns.setText("All Columns with Posterior Probability >=");
        selectcolumns.setVerticalAlignment(SwingConstants.TOP);
        selectcolumns.addActionListener(new
                AlignmentChooser_jRadioButton1_actionAdapter(this));
        entirealignment.setSelected(true);
        entirealignment.setText("Entire Alignment");
        entirealignment.setVerticalAlignment(SwingConstants.TOP);
        entirealignment.setVerticalTextPosition(SwingConstants.TOP);
        entirealignment.addActionListener(new
                AlignmentChooser_jRadioButton2_actionAdapter(this));
        jTextField1.setMaximumSize(new Dimension(50, 18));
        jTextField1.setMinimumSize(new Dimension(50, 18));
        jTextField1.setPreferredSize(new Dimension(50, 18));
        jTextField1.setSelectionEnd(3);
        jTextField1.setSelectionStart(3);
        jTextField1.setText("0.5000");
        jTextField1.addActionListener(new
                AlignmentChooser_jTextField1_actionAdapter(this));
        jButton1.setText("OK");
        jButton1.addActionListener(new AlignmentChooser_jButton1_actionAdapter(this));
        jButton2.setText("Cancel");
        jButton2.addActionListener(new AlignmentChooser_jButton2_actionAdapter(this));
        component2.setMaximumSize(new Dimension(32767, 500));
        getContentPane().add(panel1);
        box2.add(selectcolumns);
        box2.add(jTextField1);
        panel1.add(box1, java.awt.BorderLayout.CENTER);
        box4.add(component2);
        box4.add(box5);
        box5.add(jButton1);
        box5.add(jButton2);
        box5.add(component4);
        panel1.add(box4, java.awt.BorderLayout.SOUTH);
        buttonGroup1.add(entirealignment);
        buttonGroup1.add(selectcolumns);
        panel1.add(entirealignment, java.awt.BorderLayout.NORTH);
        panel1.add(box2, java.awt.BorderLayout.WEST);
    }

    public void jRadioButton2_actionPerformed(ActionEvent e) {
         //System.out.println("all alignments "+entirealignment.getModel().isSelected());
    }

    public void jTextField1_actionPerformed(ActionEvent e) {

    }

    public void jRadioButton1_actionPerformed(ActionEvent e) {
         //System.out.println("selective alignments  "+selectcolumns.getModel().isSelected());
    }

    public void jButton1_actionPerformed(ActionEvent e) {
      //action for ok part

      if(selectcolumns.getModel().isSelected())
     {
        System.setProperty("ALLALIGNMENTS","");
        System.setProperty("SELECTALIGNMENTS", jTextField1.getText());
      }
      else
      if(entirealignment.getModel().isSelected())
      {
          System.setProperty("ALLALIGNMENTS","T");
          System.setProperty("SELECTALIGNMENTS","");
      }
      dispose();
    }

    public void jButton2_actionPerformed(ActionEvent e) {
       //set environment variable
       System.setProperty("ALLALIGNMENTS","");
       System.setProperty("SELECTALIGNMENTS","");
       dispose();
    }

}


class AlignmentChooser_jButton2_actionAdapter implements ActionListener {
    private AlignmentChooser adaptee;
    AlignmentChooser_jButton2_actionAdapter(AlignmentChooser adaptee) {
        this.adaptee = adaptee;
    }

    public void actionPerformed(ActionEvent e) {
        adaptee.jButton2_actionPerformed(e);
    }
}


class AlignmentChooser_jButton1_actionAdapter implements ActionListener {
    private AlignmentChooser adaptee;
    AlignmentChooser_jButton1_actionAdapter(AlignmentChooser adaptee) {
        this.adaptee = adaptee;
    }

    public void actionPerformed(ActionEvent e) {
        adaptee.jButton1_actionPerformed(e);
    }
}


class AlignmentChooser_jTextField1_actionAdapter implements ActionListener {
    private AlignmentChooser adaptee;
    AlignmentChooser_jTextField1_actionAdapter(AlignmentChooser adaptee) {
        this.adaptee = adaptee;
    }

    public void actionPerformed(ActionEvent e) {
        adaptee.jTextField1_actionPerformed(e);
    }
}


class AlignmentChooser_jRadioButton2_actionAdapter implements ActionListener {
    private AlignmentChooser adaptee;
    AlignmentChooser_jRadioButton2_actionAdapter(AlignmentChooser adaptee) {
        this.adaptee = adaptee;
    }

    public void actionPerformed(ActionEvent e) {
        adaptee.jRadioButton2_actionPerformed(e);
    }
}


class AlignmentChooser_jRadioButton1_actionAdapter implements ActionListener {
    private AlignmentChooser adaptee;
    AlignmentChooser_jRadioButton1_actionAdapter(AlignmentChooser adaptee) {
        this.adaptee = adaptee;
    }

    public void actionPerformed(ActionEvent e) {
        adaptee.jRadioButton1_actionPerformed(e);
    }
}
