package probalign;

import java.awt.*;

import javax.swing.*;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.FileFilter;
import java.io.File;

/**
 * <p>Title: PROBALIGN</p>
 *
 * <p>Description: File chooser GUI that helps user save the alignment</p>
 *
 *
 *
 * @author Satish Chikkagoudar
 * @version Beta 1.3
 */
public class FileSaveAs extends JDialog {
    JPanel panel1 = new JPanel();
    BorderLayout borderLayout1 = new BorderLayout();
    JFileChooser jFileChooser1 = new JFileChooser();

    public FileSaveAs(Frame owner, String title, boolean modal) {
        super(owner, title, modal);
        try {
            setDefaultCloseOperation(DISPOSE_ON_CLOSE);
            jbInit();
            pack();
        } catch (Exception exception) {
            exception.printStackTrace();
        }
    }

    public FileSaveAs(String flter) {
        this(new Frame(), "Save As "+flter, false);
    }

    private void jbInit() throws Exception {
        panel1.setLayout(borderLayout1);
        jFileChooser1.setApproveButtonText("Save");
        jFileChooser1.addChoosableFileFilter(new pdfFilter());
	jFileChooser1.setAcceptAllFileFilterUsed(true);
        jFileChooser1.setCurrentDirectory(new File(System.getProperty("user.dir")));
	//jFileChooser1.setFileSelectionMode(JFileChooser.FILES_AND_DIRECTORIES );
        jFileChooser1.addActionListener(new
                                        FileSaveAs_jFileChooser1_actionAdapter(this));
        getContentPane().add(panel1);
        panel1.add(jFileChooser1, java.awt.BorderLayout.CENTER);
    }

    public void jFileChooser1_actionPerformed(ActionEvent e) {
        String chosenfile=new String();
        if (e.getActionCommand().equals("ApproveSelection")) {
                   chosenfile = jFileChooser1.getSelectedFile().toString();

                   //System.out.println("Approve!!" + msafilename);
                   System.setProperty("SAVEASFILE",chosenfile);
                   //statusBar.setText("Saving the alignment to ... "+chosenfile);
               } else {
                   chosenfile = "";
                   //System.out.println("Reject???");
               }
               //remove the dialog from the screen
        this.dispose();

    }

}
//code reference from almanac
class pdfFilter extends javax.swing.filechooser.FileFilter
{
    public boolean accept(File file) {
           String filename = file.getName();
           return (filename.endsWith(".pdf")||filename.endsWith(".fasta"));
       }
       public String getDescription() {
           return "*.pdf, *.fasta";
       }


}

class FileSaveAs_jFileChooser1_actionAdapter implements ActionListener {
    private FileSaveAs adaptee;
    FileSaveAs_jFileChooser1_actionAdapter(FileSaveAs adaptee) {
        this.adaptee = adaptee;
    }

    public void actionPerformed(ActionEvent e) {
        adaptee.jFileChooser1_actionPerformed(e);
    }
}
