package probalign;

import java.awt.*;
import java.awt.event.*;
import java.io.*;
import java.util.*;

import javax.swing.*;
import javax.swing.border.*;
import javax.swing.table.*;
import javax.imageio.ImageIO;
import java.awt.image.BufferedImage;

import com.lowagie.text.*;
import com.lowagie.text.pdf.*;

/**
 * <p>Title: Application Frame and associated code</p>
 *
 * <p> Version: 1.3 with probalign LM at the backend </p>
 * <p>Description: </p>
 *
 * <p>Last Updated on dec 1 2006, 6pm </p>
 * @author Satish Chikkagoudar, Usman Roshan
 * @version 1.3
 */

public class Frame1
    extends JFrame {
  JPanel contentPane;
  JMenuBar jMenuBar1 = new JMenuBar();
  JMenu jMenuFile = new JMenu();
  JMenuItem jMenuFileExit = new JMenuItem();
  JMenu jMenuView = new JMenu();
  JMenu jMenuHelp = new JMenu();
  JMenuItem jMenuHelpAbout = new JMenuItem();
  JLabel statusBar = new JLabel();
  JMenu jMenu1 = new JMenu();
  JMenuItem jMenuItem1 = new JMenuItem();
  JMenuItem jMenuItem2 = new JMenuItem();
  JMenuItem ungapmenu = new JMenuItem();
  JMenuItem viewscore = new JMenuItem();
  JMenuItem jMenuSaveAsFasta= new JMenuItem();
  JMenuItem jMenuSaveAsPdf= new JMenuItem();
  int ALIGN_MODE = 0;
  String savefile = new String();
  public String filename = new String();
  TitledBorder titledBorder1 = new TitledBorder("");
  JToolBar jToolBar1 = new JToolBar();
  JScrollPane jScrollPane1;
  DefaultTableModel datamodel = new DefaultTableModel();
  DefaultTableModel namedatamodel = new DefaultTableModel();
  JTable jTable1;
  JComboBox jScoreMatrix = new JComboBox();
  JCheckBox jCheckBox1 = new JCheckBox();
  JTextField jGapOpen = new JTextField();
  JLabel jLabel1 = new JLabel();
  JLabel jLabel2 = new JLabel();
  JTextField jGapExt = new JTextField();
  Component component_2 = Box.createHorizontalStrut(8);
  Component component_10 = Box.createHorizontalStrut(8);
  Component component_6 = Box.createHorizontalStrut(8);
  Component component_8 = Box.createHorizontalStrut(8);
  JLabel jLabel4 = new JLabel();
  Component component_4 = Box.createHorizontalStrut(8);
  Component component_1 = Box.createHorizontalStrut(8);
  Component component_5 = Box.createHorizontalStrut(8);
  Component component_3 = Box.createHorizontalStrut(8);
  Component component_7 = Box.createHorizontalStrut(8);
  Component component_9 = Box.createHorizontalStrut(8);
  Component component_13 = Box.createHorizontalStrut(8);
  Component component_14 = Box.createHorizontalStrut(8);
  Component component13 = Box.createHorizontalStrut(8);
  TitledBorder titledBorder2 = new TitledBorder("");
  TitledBorder titledBorder3 = new TitledBorder("");
  Component component_11 = Box.createHorizontalStrut(8);
  String ScoreMatrix = null;
  SwingWorker worker;
  float GapOpen = 0, GapExt = 0;
  int[][] nogaps = null;
  Object[][] columnscores;
  int temperature = 5, filetable1width = 0, filetable2width = 0;
  Object[][] temps = null;
  Object[][] unaligned = null, unalignednames = null;
  Object[][] names = null;
  float[] probs = null;
  int numseq;
  BorderLayout borderLayout1 = new BorderLayout();
  JTextField jTemp = new JTextField();
  Component component_15 = Box.createHorizontalStrut(10);
  Component component_12 = Box.createHorizontalStrut(8);
  JScrollPane jScrollPane2 = new JScrollPane();
  Component component11a = Box.createHorizontalStrut(8);
  Component component1v = Box.createVerticalStrut(8);
  JLabel jLabel3 = new JLabel();
  JTable jTable2;
  JSplitPane jSplitPane1 = new JSplitPane();
  JMenuItem jMenuItem5 = new JMenuItem();
  JMenuItem jMenuItem6 = new JMenuItem();
  JMenuItem jMenuSaveAs = new JMenuItem();
  //view module globals
  int Align_length = 0;
  int Align_numColumns = 0;
  int Align_numSeqs = 0;
  int[] selected;
  int[] left_selected;
  int[] right_selected;
  int newlength = 0;
  int partialviewflag = 0;
  int prev_selectedcolindex;
  boolean wasSaved = false;
  boolean firstrun = true;

  //String basedir = System.getProperty("base.dir");
  String basedir = ".";   

  public Frame1() {
    try {
      this.
          setDefaultCloseOperation(EXIT_ON_CLOSE);
      jbInit();
    }
    catch (Exception exception) {
      exception.printStackTrace();
    }
  }

  /**
   * Component initialization.
   *
   * @throws java.lang.Exception
   */
  private void jbInit() throws Exception {
    contentPane = (JPanel) getContentPane();
    contentPane.setLayout(borderLayout1);

    this.setCursor(null);
    this.setResizable(true); //false);

    setSize(new Dimension(806, 500));
    setTitle("PROBALIGN");
    System.setProperty("MSAFILE","");
    statusBar.setAlignmentX( (float) 0.5);
    statusBar.setBorder(null);
    statusBar.setDoubleBuffered(true);
    statusBar.setOpaque(false);
    statusBar.setText(" PROBALIGN");

    jMenuFile.setText("File");
    jMenuItem2.setText("Open");
    jMenuSaveAs.setText("Save As");
    jMenuSaveAsPdf.setText("Save As PDF");
    jMenuSaveAsFasta.setText("Save As FASTA");
    jMenuSaveAsPdf.addActionListener(new Frame1_jMenuSaveAsPdf_actionAdapter(this));
    jMenuSaveAsFasta.addActionListener(new Frame1_jMenuSaveAsFasta_actionAdapter(this));

    jMenuFileExit.setText("Exit");
    jMenuFileExit.addActionListener(new Frame1_jMenuFileExit_ActionAdapter(this));

    jMenuHelp.setText("Help");
    jMenuHelpAbout.setText("About");
    jMenuHelpAbout.addActionListener(new
                                     Frame1_jMenuHelpAbout_ActionAdapter(this));

    jMenuItem2.addActionListener(new
                                 Frame1_jMenuItem2_ActionAdapter(this));

    jMenu1.setText("Align");
    jMenuView.setText("View");
    jMenuItem1.setText("Run");
    jMenuItem1.addActionListener(new Frame1_jMenuItem1_ActionAdapter(this));
    jMenuBar1.setForeground(Color.gray);
    jMenuBar1.setAlignmentY( (float) 0.5);
    jMenuBar1.setBorder(null);

    jCheckBox1.setMaximumSize(new Dimension(150, 20));
    jCheckBox1.setMinimumSize(new Dimension(150, 20));
    jCheckBox1.setPreferredSize(new Dimension(150, 20));
    jCheckBox1.setText("No Gaps");
    jCheckBox1.addActionListener(new Frame1_jCheckBox1_actionAdapter(this));
    jGapOpen.setBorder(BorderFactory.createLineBorder(Color.black));
    jGapOpen.setMaximumSize(new Dimension(50, 18));
    jGapOpen.setMinimumSize(new Dimension(40, 18));
    jGapOpen.setPreferredSize(new Dimension(40, 18));
    jGapOpen.setInputVerifier(null);
    jGapOpen.setCaretPosition(0);
    jGapOpen.setText("0.0");
    jGapOpen.setHorizontalAlignment(SwingConstants.CENTER);
    jGapOpen.addActionListener(new Frame1_jTextField1_actionAdapter(this));

    jLabel1.setOpaque(true);
    jLabel1.setText("Gap Open");
    jLabel2.setText("Gap Extend");
    jGapExt.setBorder(BorderFactory.createLineBorder(Color.black));
    jGapExt.setMaximumSize(new Dimension(50, 18));
    jGapExt.setMinimumSize(new Dimension(40, 18));
    jGapExt.setPreferredSize(new Dimension(40, 18));
    jGapExt.setCaretPosition(0);
    jGapExt.setText("0.0");
    jGapExt.setHorizontalAlignment(SwingConstants.CENTER);
    jGapExt.addActionListener(new Frame1_jTextField2_actionAdapter(this));
    jScoreMatrix.setBackground(Color.lightGray);
    jScoreMatrix.setBorder(BorderFactory.createLineBorder(Color.black));
    jScoreMatrix.setDoubleBuffered(true);
    jScoreMatrix.setMaximumSize(new Dimension(120, 18));
    jScoreMatrix.setMinimumSize(new Dimension(110, 18));
    jScoreMatrix.setPreferredSize(new Dimension(110, 18));
    jScoreMatrix.setToolTipText("");
    jScoreMatrix.addActionListener(new Frame1_jComboBox1_actionAdapter(this));
    jToolBar1.setBackground(Color.lightGray);
    jToolBar1.setAlignmentX( (float) 1);
    jToolBar1.setAlignmentY( (float) 1);
    jToolBar1.setBorder(null);
    jToolBar1.setDebugGraphicsOptions(0);
    jToolBar1.setDoubleBuffered(true);
    jToolBar1.setOpaque(false);
    jToolBar1.setToolTipText("");
    jToolBar1.setBorderPainted(false);
    jToolBar1.setMargin(new Insets(0, 0, 0, 0));
    jToolBar1.setPreferredSize(new Dimension(806, 30));
    //java almanac..ref

    jTable1 = new JTable() {
      public boolean isCellEditable(int rowIndex, int vColIndex) {
        return false;
      }
    };
    jTable2 = new JTable() {
      public boolean isCellEditable(int rowIndex, int vColIndex) {
        return false;
      }
    };
    jScrollPane1 = new JScrollPane(jTable1);
    jScrollPane1.setViewportBorder(null);

    jScrollPane1.setAutoscrolls(true);
    jScrollPane1.setBorder(BorderFactory.createLineBorder(Color.black));

    jScrollPane1.setHorizontalScrollBarPolicy(JScrollPane.
                                              HORIZONTAL_SCROLLBAR_ALWAYS);

    jScrollPane1.setToolTipText("");
    jLabel4.setText("Scoring Matrix");
    jTable1.setBackground(Color.white); //lightGray);
    jTable1.setEnabled(true);

    jTable1.setFont(new java.awt.Font("Dialog", java.awt.Font.PLAIN, 10));
    jTable1.setForeground(Color.darkGray);
    jTable1.setAlignmentX( (float) 0.0);
    jTable1.setAlignmentY( (float) 0.0);
    jTable1.setBorder(null);
    jTable1.setDoubleBuffered(true);
    jTable1.setIntercellSpacing(new Dimension(0, 0));
    jTable1.setRowMargin(0);
    jTable1.setOpaque(true);
    jTable1.setToolTipText("");
    jTable1.setVerifyInputWhenFocusTarget(false);
    jTable1.setAutoResizeMode(JTable.AUTO_RESIZE_OFF);
    jTable1.setColumnSelectionAllowed(true);
    jTable1.setGridColor(Color.lightGray);
    jTable1.setSelectionForeground(Color.darkGray);
    jTable1.setShowHorizontalLines(false);
    jTable1.setShowVerticalLines(false);
    jTable1.addKeyListener(new Frame1_jTable1_keyAdapter(this));
    jTable1.addMouseListener(new Frame1_jTable1_mouseAdapter(this));

    jTemp.setMaximumSize(new Dimension(50, 18));
    jTemp.setMinimumSize(new Dimension(40, 18));
    jTemp.setPreferredSize(new Dimension(40, 18));
    jTemp.setText("5");
    jTemp.setBorder(BorderFactory.createLineBorder(Color.black));
    jTemp.setHorizontalAlignment(SwingConstants.CENTER);
    jLabel3.setText("T");

    jScrollPane2.setVerticalScrollBarPolicy(JScrollPane.
                                            VERTICAL_SCROLLBAR_NEVER);
    jScrollPane2.setHorizontalScrollBarPolicy(JScrollPane.
                                              HORIZONTAL_SCROLLBAR_ALWAYS);
    //was NEVER before
    jScrollPane2.setBorder(BorderFactory.createLineBorder(Color.black));

    // Listen for value changes in the scroll pane's scrollbars
    AdjustmentListener listener1 = new MyAdjustmentListener1();
    AdjustmentListener listener2 = new MyAdjustmentListener2();
    jScrollPane1.getVerticalScrollBar().addAdjustmentListener(listener1);
    jScrollPane2.getVerticalScrollBar().addAdjustmentListener(listener2);

    jTable2.setFont(new java.awt.Font("Dialog", java.awt.Font.PLAIN, 10));
    jTable2.setBorder(null);
    jTable2.setDoubleBuffered(true);
    jTable2.setOpaque(true);
    jTable2.setBackground(Color.lightGray);
    jTable2.setAlignmentX( (float) 0.0);
    jTable2.setAlignmentY( (float) 0.0);
    jTable2.setAutoResizeMode(JTable.AUTO_RESIZE_OFF);
    jTable2.setCellSelectionEnabled(false); //true);
    jTable2.setIntercellSpacing(new Dimension(0, 0));
    jTable2.setModel(namedatamodel);
    jTable2.setShowHorizontalLines(false);
    jTable2.setShowVerticalLines(false);
    jTable2.setShowGrid(false);
    jTable1.setRowMargin(0);
    jTable2.setSelectionForeground(Color.darkGray);
    jSplitPane1.setMinimumSize(new Dimension(100, 100));
    jSplitPane1.setContinuousLayout(true);
    jSplitPane1.setLastDividerLocation( -1);
    jSplitPane1.setOneTouchExpandable(true);
    viewscore.addActionListener(new Frame1_viewscore_actionAdapter(this));
    viewscore.setText("Probabilities");
    jMenuItem5.setText("Alignment");
    jMenuItem5.addActionListener(new Frame1_jMenuItem5_actionAdapter(this));
    jMenuItem6.setText("Ungap");
    jMenuItem6.addActionListener(new Frame1_jMenuItem6_actionAdapter(this));
    jMenuBar1.add(jMenuFile);
    jMenuBar1.add(jMenuView);
    jMenuBar1.add(jMenu1);
    jMenuBar1.add(jMenuHelp);
    jMenuHelp.add(jMenuHelpAbout);
    jMenuView.add(viewscore);
    jMenuView.add(jMenuItem5);
    jMenuView.add(jMenuItem6);
    setJMenuBar(jMenuBar1);
    jMenu1.add(jMenuItem1);
    jMenuFile.add(jMenuItem2);
    jMenuFile.add(jMenuSaveAsPdf);
    jMenuFile.add(jMenuSaveAsFasta);
    jMenuFile.add(jMenuFileExit);
    jToolBar1.add(component13);
    jToolBar1.add(jLabel1);
    jToolBar1.add(component_1);
    jToolBar1.add(jGapOpen);
    jToolBar1.add(component_2);
    jToolBar1.add(component_3);
    jToolBar1.add(component_4);
    jToolBar1.add(jLabel2);
    jToolBar1.add(component_5);
    jToolBar1.add(jGapExt);
    jToolBar1.add(component_6);
    jToolBar1.add(component_7);
    jToolBar1.add(component_8);
    jToolBar1.add(jLabel3);
    jToolBar1.add(component_9);
    jToolBar1.add(jTemp);
    jToolBar1.add(component_11);
    jToolBar1.add(component_10);
    jToolBar1.add(component11a);
    jToolBar1.add(jLabel4);
    jToolBar1.add(component_12);
    jToolBar1.add(jScoreMatrix);
    jToolBar1.add(component_13);
    jToolBar1.add(component_14);
    jToolBar1.add(component_15);
    //jToolBar1.add(jCheckBox1);
    contentPane.add(statusBar, java.awt.BorderLayout.SOUTH);

    jSplitPane1.add(jScrollPane1, JSplitPane.RIGHT);
    jScrollPane1.getViewport().add(jTable1);
    jSplitPane1.add(jScrollPane2, JSplitPane.LEFT);
    jScrollPane2.getViewport().add(jTable2);
    contentPane.add(jSplitPane1, java.awt.BorderLayout.CENTER);
    contentPane.add(jToolBar1, java.awt.BorderLayout.NORTH);
    jScoreMatrix.insertItemAt("gonnet_160", 0);
    jScoreMatrix.insertItemAt("nuc_simple", 1);
    jScoreMatrix.setSelectedIndex(0);
    jTable1.setTableHeader(null);
    jTable2.setTableHeader(null);
    jSplitPane1.setDividerLocation(100);

    //MENUITEM STATUS
    jMenuItem1.setEnabled(false);
    jMenuSaveAsPdf.setEnabled(false);
    jMenuSaveAsFasta.setEnabled(false);
    jMenuItem5.setEnabled(false);
    jMenuItem6.setEnabled(false);
    viewscore.setEnabled(false);
  }

  /**
   * File | Exit action performed.
   *
   * @param actionEvent ActionEvent
   */
  void jMenuFileExit_actionPerformed(ActionEvent actionEvent) {
    System.exit(0);
  }

  /**
   * Help | About action performed.
   *
   * @param actionEvent ActionEvent
   */
  void jMenuHelpAbout_actionPerformed(ActionEvent actionEvent) {
    Frame1_AboutBox dlg = new Frame1_AboutBox(this);
    Dimension dlgSize = dlg.getPreferredSize();
    Dimension frmSize = getSize();
    Point loc = getLocation();
    dlg.setLocation( (frmSize.width - dlgSize.width) / 2 + loc.x,
                    (frmSize.height - dlgSize.height) / 2 + loc.y);
    dlg.setModal(true);
    dlg.pack();
    dlg.setVisible(true);

  }

  /**
   * file save action
   *
   * @param e ActionEvent
   */



  public void jMenuSaveAsPdf_actionPerformed(ActionEvent e) {
    //save action

    String os_name = System.getProperty("os.name").toLowerCase();

    if (os_name.indexOf("mac") != -1) {
      FileSaveActionForMac(e,"pdf");
    }
    else {
      FileSaveActionForNonMac(e,"pdf");
    }

  }

  public void jMenuSaveAsFasta_actionPerformed(ActionEvent e) {
    //save action

    String os_name = System.getProperty("os.name").toLowerCase();

    if (os_name.indexOf("mac") != -1) {
      FileSaveActionForMac(e,"fasta");
    }
    else {
      FileSaveActionForNonMac(e,"fasta");
    }

  }

  public void FileSaveActionForNonMac(ActionEvent e,String flter) {

    FileSaveAs dlg = new FileSaveAs(flter);
    Dimension dlgSize = dlg.getPreferredSize();
    Dimension frmSize = getSize();
    Point loc = getLocation();
    dlg.setLocation( (frmSize.width - dlgSize.width) / 2 + loc.x,
                    (frmSize.height - dlgSize.height) / 2 + loc.y);
    dlg.setModal(true);
    dlg.pack();
    dlg.setVisible(true);

    final String savefile = System.getProperty("SAVEASFILE");
    //pdf/text saving part

    if (savefile != null) {
      SwingWorker worker = new SwingWorker() {

        public Object construct() {
          jMenuItem1.setEnabled(false);
          jMenuSaveAsFasta.setEnabled(false);
          jMenuSaveAsPdf.setEnabled(false);
	  jMenuItem5.setEnabled(false);
          jMenuItem6.setEnabled(false);
          viewscore.setEnabled(false);
	  statusBar.setIcon(new ImageIcon(basedir+"/javagui/images/a.gif",
                                          "Saving"));
          statusBar.setText(" Saving Alignment to " + savefile);
          if (savefile.toLowerCase().lastIndexOf(".pdf") != -1) {
            if (partialviewflag == 0) {
              pages_to_pdf(savefile);
            }
            else {
              partial_pages_to_pdf(savefile);
            }
          }
          else {
            saveAlignmentToFasta(savefile);
          }
          return null;
        }

        public void finished() {
          wasSaved = true;
          jMenuItem1.setEnabled(true);
          jMenuSaveAsFasta.setEnabled(true);
          jMenuSaveAsPdf.setEnabled(true);
	  jMenuItem5.setEnabled(true);
          jMenuItem6.setEnabled(true);
          viewscore.setEnabled(true);
          statusBar.setIcon(null);
          statusBar.setText(" Saved Alignment to " + savefile);
        }

      };

      worker.start();

    }

  }

  /**
   * fileopen action
   * @param actionEvent ActionEvent
   */

  public void jMenuItem2_actionPerformed(ActionEvent actionEvent) {
    //file open action
    //alert!
    String os_name = System.getProperty("os.name").toLowerCase();

    if (os_name.indexOf("mac") != -1) {
      FileOpenActionForMac(actionEvent);
    }
    else {
      FileOpenActionForNonMac(actionEvent);
    }

  }

  /**
   * File Open action for non mac systems
   * @param actionEvent ActionEvent
   */
  public void FileOpenActionForNonMac(ActionEvent actionEvent) {
    Point loc;
    Dimension frmSize;
    if (!wasSaved && !firstrun) {
      reminder savedlg = new reminder(this, "Reminder", true);

      Dimension savedlgSize = savedlg.getPreferredSize();
      frmSize = getSize();
      loc = getLocation();
      savedlg.setLocation( (frmSize.width - savedlgSize.width) / 2 + loc.x,
                          (frmSize.height - savedlgSize.height) / 2 +
                          loc.y);
      savedlg.setModal(true);

      savedlg.pack();
      savedlg.setVisible(true);
      if (System.getProperty("saveoption").equals("N")) {
        wasSaved = true;
      }

    }

    if (wasSaved || firstrun) {

      FileOpen dlg = new FileOpen(this, "Open", true, statusBar);

      Dimension dlgSize = dlg.getPreferredSize();
      frmSize = getSize();
      loc = getLocation();
      dlg.setLocation( (frmSize.width - dlgSize.width) / 2 + loc.x,
                      (frmSize.height - dlgSize.height) / 2 + loc.y);
      dlg.setModal(true);

      dlg.pack();
      dlg.setVisible(true);

      if (!System.getProperty("MSAFILE").equals("")) {
        filename = System.getProperty("MSAFILE");
      }

      if (!filename.equals("") && !System.getProperty("MSAFILE").equals("")) {


       unaligned = null;
       temps = null;
       unalignednames = null;
       nogaps = null;
       columnscores = null;
       jTable1.invalidate();
       jTable2.invalidate();


        //SwingWorker worker = new SwingWorker() {

        //  public Object construct() {

            jMenuItem1.setEnabled(false);
            jMenuSaveAsFasta.setEnabled(false);
            jMenuSaveAsPdf.setEnabled(false);
            jMenuItem5.setEnabled(false);
            jMenuItem6.setEnabled(false);
            viewscore.setEnabled(false);


            DoLoadFile();

	 //   return null;
        //  }

       //   public void finished() {

            jMenuItem1.setEnabled(true);
            jTable1.revalidate();
            jTable2.revalidate();
            jTable1.repaint();
            jTable2.repaint();

        //  }

      //  };

     //   worker.start();
      }
    }
    else { //save if not saved and user wants it saved
      //save action
      FileSaveAs dlg = new FileSaveAs(" fasta");
      Dimension dlgSize = dlg.getPreferredSize();
      frmSize = getSize();
      loc = getLocation();
      dlg.setLocation( (frmSize.width - dlgSize.width) / 2 + loc.x,
                      (frmSize.height - dlgSize.height) / 2 + loc.y);
      dlg.setModal(true);
      dlg.pack();
      dlg.setVisible(true);

      final String savefile = System.getProperty("SAVEASFILE");
      //pdf/text saving part

      if (savefile != null) {
        SwingWorker worker = new SwingWorker() {

          public Object construct() {
            jMenuItem1.setEnabled(false);
            jMenuSaveAsFasta.setEnabled(false);
            jMenuSaveAsPdf.setEnabled(false);
            jMenuItem5.setEnabled(false);
            jMenuItem6.setEnabled(false);
            viewscore.setEnabled(false);
	    statusBar.setIcon(new ImageIcon(basedir+"/javagui/images/a.gif",
                                          "Saving"));
            statusBar.setText(" Saving Alignment to " + savefile);
            if (savefile.toLowerCase().lastIndexOf(".pdf") != -1) {
              if (partialviewflag == 0) {
                pages_to_pdf(savefile);
              }
              else {
                partial_pages_to_pdf(savefile);
              }
            }
            else {
              saveAlignmentToFasta(savefile);
            }
            return null;
          }

          public void finished() {
            wasSaved = true;
            jMenuItem1.setEnabled(true);
            jMenuSaveAsFasta.setEnabled(true);
            jMenuSaveAsPdf.setEnabled(true);
            jMenuItem5.setEnabled(true);
            jMenuItem6.setEnabled(true);
            viewscore.setEnabled(true);
	    statusBar.setIcon(null);
            statusBar.setText(" Saved Alignment to " + savefile);
          }

        };

        worker.start();

      }

    }
  }


  /**
   * File Open Action for Mac systems
   *
   * @param actionEvent ActionEvent
   */
  void FileOpenActionForMac(ActionEvent actionEvent) {
    //file open action
    //alert!
    Point loc;
    Dimension frmSize;
    if (!wasSaved && !firstrun) {
      reminder savedlg = new reminder(this, "Reminder", true);

      Dimension savedlgSize = savedlg.getPreferredSize();
      frmSize = getSize();
      loc = getLocation();
      savedlg.setLocation( (frmSize.width - savedlgSize.width) / 2 + loc.x,
                          (frmSize.height - savedlgSize.height) / 2 +
                          loc.y);
      savedlg.setModal(true);

      savedlg.pack();
      savedlg.setVisible(true);
      if (System.getProperty("saveoption").equals("N")) {
        wasSaved = true;
      }

    }

    if (wasSaved || firstrun) {

      //FileOpen dlg = new FileOpen(this, "Open", true, statusBar);

      FileDialog dlg = new FileDialog(this, "Open", FileDialog.LOAD);

      Dimension dlgSize = dlg.getPreferredSize();
      frmSize = getSize();
      loc = getLocation();
      dlg.setLocation( (frmSize.width - dlgSize.width) / 2 + loc.x,
                      (frmSize.height - dlgSize.height) / 2 + loc.y);
      dlg.setModal(true);
      dlg.setUndecorated(true);
      //dlg.pack();
      dlg.setVisible(true);

      if (dlg.getDirectory() != null && dlg.getFile() != null) {

        filename = dlg.getDirectory() + dlg.getFile();
        System.setProperty("MSAFILE", filename);
        statusBar.setText(" MSAFILE Selected is " + filename);
      }
      else {
        System.setProperty("MSAFILE", "");
      }

      if (!filename.equals("") && !System.getProperty("MSAFILE").equals("")) {


         unaligned = null;
    temps = null;
    unalignednames = null;
    nogaps = null;
    columnscores = null;
    jTable1.invalidate();
    jTable2.invalidate();


//SwingWorker worker = new SwingWorker() {

//        public Object construct() {

            jMenuItem1.setEnabled(false);
            jMenuSaveAsFasta.setEnabled(false);
            jMenuSaveAsPdf.setEnabled(false);
            jMenuItem5.setEnabled(false);
            jMenuItem6.setEnabled(false);
            viewscore.setEnabled(false);
            DoLoadFile();
  //          return null;
  //      }

  //    public void finished() {

            jMenuItem1.setEnabled(true);
            jTable1.revalidate();
            jTable2.revalidate();
            jTable1.repaint();
            jTable2.repaint();
    //      }

      //  };

     //   worker.start();
      }
    }
    else { //save if not saved and user wants it saved
      //save action
      //FileSaveAs dlg = new FileSaveAs();
      FileDialog dlg = new FileDialog(this, "Save", FileDialog.SAVE);
      Dimension dlgSize = dlg.getPreferredSize();
      frmSize = getSize();
      loc = getLocation();
      dlg.setLocation( (frmSize.width - dlgSize.width) / 2 + loc.x,
                      (frmSize.height - dlgSize.height) / 2 + loc.y);
      dlg.setModal(true);
      dlg.pack();
      dlg.setVisible(true);

      if (dlg.getDirectory() != null && dlg.getFile() != null) {
        savefile = dlg.getDirectory() + dlg.getFile();
        System.setProperty("SAVEASFILE", savefile);
      }

      //pdf/text saving part

      if (savefile != null && !savefile.equals("")) {
        SwingWorker worker = new SwingWorker() {

          public Object construct() {
            jMenuItem1.setEnabled(false);
            jMenuSaveAsFasta.setEnabled(false);
            jMenuSaveAsPdf.setEnabled(false);
            jMenuItem5.setEnabled(false);
            jMenuItem6.setEnabled(false);
            viewscore.setEnabled(false);
            statusBar.setIcon(new ImageIcon(basedir+"/javagui/images/a.gif",
                                          "Saving"));
            statusBar.setText(" Saving Alignment to " + savefile);
            if (savefile.toLowerCase().lastIndexOf(".pdf") != -1) {
              if (partialviewflag == 0) {
                pages_to_pdf(savefile);
              }
              else {
                partial_pages_to_pdf(savefile);
              }
            }
            else {
              saveAlignmentToFasta(savefile);
            }
            return null;
          }

          public void finished() {
            wasSaved = true;
            jMenuItem1.setEnabled(true);
            jMenuSaveAsFasta.setEnabled(true);
            jMenuSaveAsPdf.setEnabled(true);
            jMenuItem5.setEnabled(true);
            jMenuItem6.setEnabled(true);
            viewscore.setEnabled(true);
            statusBar.setIcon(null);
	    statusBar.setText(" Saved Alignment to " + savefile);
          }

        };

        worker.start();

      }

    }
  }


  /**
   * Loads the unaligned input MSA file onto the screen
   *
   */
  void DoLoadFile() {

    String line = null;
    int maxlength = 0;

    int j = -1;


    String namestring = null, sequencestring = null;
    int ii = 0, templength = 0;
    int alignmentflag = 0, lineno = 0;
    int numColumns = 0, numSeqs = 0, nongapcount = 0;
    int maxnamelength = 0;
    String[] splitter = new String[2];

    try {

      BufferedReader grep = new BufferedReader(new FileReader(filename));

      while ( (line = grep.readLine()) != null) {
        if (line.lastIndexOf(">") != -1) {
          numSeqs++;
        }

      }
      grep.close();
      BufferedReader infile = new BufferedReader(new FileReader(filename));
      unalignednames = new Object[numSeqs][1];
      unaligned = new Object[numSeqs][1];
      numseq = numSeqs;
      while ( (line = infile.readLine()) != null) {

        if (templength > maxlength) {
          maxlength = templength;
        }

        if (line.lastIndexOf(">") != -1) {

          j++;
          if (j > 0) {
            unaligned[j - 1][0] = sequencestring;
          }

          ii = 0;
          unalignednames[j][0] = line.replace('>', ' ');
          if (maxnamelength < line.length()) {
            maxnamelength = line.length();
          }
          sequencestring = new String();
          unaligned[j][0] = "";
          templength = 0;
          continue;

        }

        templength += line.length();
        sequencestring += line;

      }

      unaligned[j][0] = sequencestring;

      datamodel.setDataVector(unaligned, new Object[1]);
      namedatamodel.setDataVector(unalignednames, new Object[1]);

      jTable1.setModel(datamodel);
      jTable2.setModel(namedatamodel);
      //Get the column model.

      filetable2width = maxnamelength *
          jTable2.getFontMetrics(jTable2.getFont()).
          charWidth('W');
      filetable1width = maxlength *
          jTable1.getFontMetrics(jTable1.getFont()).
          charWidth('W');

      TableColumnModel namecolModel = jTable2.getColumnModel();
      namecolModel.setColumnMargin(0);
      namecolModel.getColumn(0).setMinWidth(filetable2width);
      namecolModel.getColumn(0).sizeWidthToFit();

      TableColumnModel colModel = jTable1.getColumnModel();
      colModel.setColumnMargin(0);

      TableColumn tc1 = namecolModel.getColumn(0);
      tc1.setCellRenderer(new MyNameCellRenderer(1, numSeqs));

      TableColumn tc2 = colModel.getColumn(0);
      tc2.setCellRenderer(new MyNameCellRenderer(1, numSeqs));
      colModel.getColumn(0).setMinWidth(filetable1width);

      statusBar.setText(" Loaded " + filename);

      infile.close();

    }
    catch (IOException e) {
      System.out.println(e);
    }

  }

  /**
   * loads an ungapped version of alignment onto screen
   *
   */
  void DoUnGap() {

    datamodel.setDataVector(unaligned, new Object[1]);
    namedatamodel.setDataVector(unalignednames, new Object[1]);

    jTable1.setModel(datamodel);

    jTable2.setModel(namedatamodel);
    //Get the column model.

    TableColumnModel namecolModel = jTable2.getColumnModel();
    namecolModel.setColumnMargin(0);
    namecolModel.getColumn(0).setMinWidth(filetable2width);
    namecolModel.getColumn(0).sizeWidthToFit();

    TableColumnModel colModel = jTable1.getColumnModel();
    colModel.setColumnMargin(0);

    //Get the column at index pColumn, and set its preferred width.


    TableColumn tc1 = namecolModel.getColumn(0);

    tc1.setCellRenderer(new MyNameCellRenderer(1, numseq));

    TableColumn tc2 = colModel.getColumn(0);
    tc2.setCellRenderer(new MyNameCellRenderer(1, numseq));

    colModel.getColumn(0).setMinWidth(filetable1width);

    statusBar.setText(" Loaded " + filename);

  }

  /**
   * align!
   * @param actionEvent ActionEvent
   */

  void jMenuItem1_actionPerformed(ActionEvent actionEvent) {
    //action for align
    ALIGN_MODE = 0;
    SwingWorker worker = new SwingWorker() {

      public Object construct() {
        jMenuItem1.setEnabled(false);
        jMenuSaveAsFasta.setEnabled(false);
        jMenuSaveAsPdf.setEnabled(false);
        jMenuItem5.setEnabled(false);
        jMenuItem6.setEnabled(false);
        viewscore.setEnabled(false);
        DoProbalignRuns();

        return null;
      }

      public void finished() {
        wasSaved = false;
        firstrun = false;
        jMenuItem1.setEnabled(true);
        jMenuSaveAsFasta.setEnabled(true);
        jMenuSaveAsPdf.setEnabled(true);
        jMenuItem5.setEnabled(true);
        jMenuItem6.setEnabled(true);
        viewscore.setEnabled(true);

        Runtime rt = Runtime.getRuntime();
        rt.gc();
        jTable2.revalidate();
        jTable1.revalidate();
        jTable1.repaint();
        jTable2.repaint();
      }

    };

    worker.start();

  }

  /**
   * run probalign
   *
   */
  void DoProbalignRuns() { //align

    //filename = System.getProperty("MSAFILE");

    //enable for windows
    //String command = new String("c:/probalign/PROBALIGN ");
    //command = command + "\"" + filename + "\"";

    //method 2..to use comment out earlier assignment and assign
    //this to it instead
    //System.getenv("PROBALIGN_HOME");

    //unix code
    String command = new String(basedir+"/probalign/bin/probalign "); 
    command = command + filename;

    GapOpen = Float.parseFloat(jGapOpen.getText());
    GapExt = Float.parseFloat(jGapExt.getText());
    temperature = Integer.parseInt(jTemp.getText());

    command = command + " -T " + temperature;

    if (GapOpen != 0.0) {
      command = command + " -go " + GapOpen;
    }

    if (GapExt != 0.0) {
      command = command + " -ge " + GapExt;
    }

    if (ScoreMatrix != null) {
      command = command + " -score_matrix " + ScoreMatrix;
    }

    statusBar.setText(" Processing  " + filename);
    System.setSecurityManager(null);
    try {
      Runtime rt = Runtime.getRuntime();
      rt.gc();
      Process proc = rt.exec(command + " -gui");

      InputStream instream = proc.getInputStream();
      InputStreamReader coutisr = new InputStreamReader(instream);
      BufferedReader coutbr = new BufferedReader(coutisr);

      InputStream stderr = proc.getErrorStream();
      InputStreamReader errisr = new InputStreamReader(stderr);
      BufferedReader errbr = new BufferedReader(errisr);

      PrintWriter out = new PrintWriter(new FileWriter(basedir+"/javagui/tempfiles/align.fasta"));

      char extra = '|';
      String line = null;
      int maxlength = 0;
      //cout stream handled here
      int j = 0;
      temps = null;
      names = null;
      columnscores = null;
      nogaps = null;
      probs = null;
      int ii = 0, templength = 0;
      int alignmentflag = 0, lineno = 0, maxnamelength = 0,
          namelength = 0;
      int numColumns = 0, numSeqs = 0, nongapcount = 0;
      String[] splitter = new String[2];
      int last_lineno = 0, prob_progress_flag = 0, combinations = 0;

      while ( (line = coutbr.readLine()) != null) {

        if (maxlength < templength) {
          maxlength = templength;
        }

        if (line.lastIndexOf(">") != -1) {
          out.println(line);
          lineno++;
          j++;
          nongapcount = 0;
          ii = 0;
          names[j][0] = line.replace('>', ' ');

          templength = 0;
          //namelength=line.length();
          //if(namelength > maxnamelength)
          //   maxnamelength = namelength;
          alignmentflag = 1;
          continue;

        }

        if (line.lastIndexOf("@+") != -1) {
          lineno++;
          prob_progress_flag = 1;
          continue;

        }

        if (line.lastIndexOf("@-") != -1) {

          prob_progress_flag = 0;
          last_lineno = lineno;
          lineno++;
          statusBar.setIcon(new ImageIcon(basedir+"/javagui/images/a.gif",
                                          "Aligning"));
          statusBar.setText(" Aligning ");
          continue;
        }

        if (prob_progress_flag == 1) {
          statusBar.setText(
              " Calculating Posterior Probabilities ....  " +
              (Integer.parseInt(line) * 100) / combinations +
              "% done");
        }

        if (prob_progress_flag == 0 && lineno > (last_lineno + 2) &&
            lineno < (last_lineno + numColumns + 3)) {

          splitter = line.split(" ");
          probs[Integer.parseInt(splitter[0]) -
              1] = Float.parseFloat(splitter[1]);
          columnscores[ii][0] = splitter[0];
          columnscores[ii][1] = splitter[1];

          temps[j][ii++] = String.valueOf( (int) (Float.parseFloat(
              splitter[1]) * 10));
        }

        if (lineno == 0) {
          numSeqs = Integer.parseInt(line);
          combinations = (int) (numSeqs * (numSeqs - 1) / 2.0);

        }

        if (lineno == (last_lineno + 1)) {

          numColumns = Integer.parseInt(line);
          //System.out.println(numColumns);
          temps = new Object[numSeqs + 1][numColumns]; //+ 1]; //1 extra to fit name
          nogaps = new int[numSeqs + 1][numColumns]; // + 1];
          probs = new float[numColumns]; // + 1];
          names = new Object[numSeqs + 1][1];
          columnscores = new Object[numColumns][2];
          names[0][0] = "";
        }

        lineno++;
        if (alignmentflag == 0) {
          continue;
        }

        out.println(line);
        char[] temp = line.toCharArray();
        templength += temp.length;

        for (int i = 0; i < temp.length; i++) {
          if (temp[i] != '\n' || temp[i] != '\t' || temp[i] != ' ') {
            temps[j][ii] = String.valueOf(temp[i]);
            if (temp[i] != '-') {
              nogaps[j][ii] = ++nongapcount;
            }
            else {
              nogaps[j][ii] = nongapcount;
            }
            ii++;
          }

        }

      }
      statusBar.setIcon(null);
      statusBar.setText("Alignment Done");
      //view module variables
      Align_length = maxlength;
      Align_numColumns = numColumns;
      Align_numSeqs = numSeqs;

      datamodel.setDataVector(temps, new Object[maxlength]);
      namedatamodel.setDataVector(names, new Object[1]);

      jTable1.setModel(datamodel);

      jTable2.setModel(namedatamodel);
      //Get the column model.

      TableColumnModel namecolModel = jTable2.getColumnModel();
      namecolModel.setColumnMargin(0);

      TableColumnModel colModel = jTable1.getColumnModel();
      colModel.setColumnMargin(0);

      //Get the column at index pColumn, and set its preferred width.


      TableColumn tc1 = namecolModel.getColumn(0);
      namecolModel.getColumn(0).setMaxWidth(1000);
      namecolModel.getColumn(0).setMinWidth(1000);

      //save processing time
      //maxnamelength*(jTable2.getFontMetrics(jTable2.getFont()).charWidth('W')));

      tc1.setCellRenderer(new MyNameCellRenderer(numColumns, numSeqs));

      char valuelookingat;
      int maxwidth = 0, currwidth;
      for (int i = 0; i < maxlength; i++) {
        maxwidth = 0;
        colModel.getColumn(i).setMinWidth(0);

        for (j = 0; j <= numSeqs; j++) {
          valuelookingat = (temps[j][i].toString()).charAt(0);
          currwidth = jTable1.getFontMetrics(jTable1.getFont()).
              charWidth(valuelookingat);
          if (currwidth > maxwidth) {
            maxwidth = currwidth;
          }
        }
        colModel.getColumn(i).setMaxWidth(maxwidth); //+1);

        colModel.getColumn(i).sizeWidthToFit();

        colModel.getColumn(i).setCellRenderer(new MyTableCellRenderer(
            numColumns, numSeqs, statusBar, probs));
      }

      statusBar.setText(" Processing  " + filename);
      //cerr handled here
      line = null;

      while ( (line = errbr.readLine()) != null) {
        //System.out.println(line);
      }

      int exitVal = proc.waitFor();

      statusBar.setText(" Processed  " + filename);

      errbr.close();
      coutbr.close();
      coutisr.close();
      errisr.close();
      instream.close();
      stderr.close();
      out.close();
    }
    catch (Exception t) {
      t.printStackTrace();
    }

  }


/**
   *
   * VIEW ALIGNMENT MODULE
 */

  void DoViewEntireAlignment() {
    //view

    partialviewflag = 0;
    //variables used:
    //Align_length: maxlength;
    //Align_numColumns: numColumns;

    datamodel.setDataVector(temps, new Object[Align_length]);
    namedatamodel.setDataVector(names, new Object[1]);

    jTable1.setModel(datamodel);

    jTable2.setModel(namedatamodel);
    //Get the column model.

    TableColumnModel namecolModel = jTable2.getColumnModel();
    namecolModel.setColumnMargin(0);

    TableColumnModel colModel = jTable1.getColumnModel();
    colModel.setColumnMargin(0);

    //Get the column at index pColumn, and set its preferred width.


    TableColumn tc1 = namecolModel.getColumn(0);
    namecolModel.getColumn(0).setMaxWidth(1000);
    namecolModel.getColumn(0).setMinWidth(1000);

    //save processing time
    //maxnamelength*(jTable2.getFontMetrics(jTable2.getFont()).charWidth('W')));

    tc1.setCellRenderer(new MyNameCellRenderer(Align_numColumns,
                                               Align_numSeqs));

    char valuelookingat;
    int maxwidth = 0, currwidth, i, j;
    for (i = 0; i < Align_length; i++) {
      maxwidth = 0;
      colModel.getColumn(i).setMinWidth(0);

      for (j = 0; j <= Align_numSeqs; j++) {
        valuelookingat = (temps[j][i].toString()).charAt(0);
        currwidth = jTable1.getFontMetrics(jTable1.getFont()).
            charWidth(valuelookingat);
        if (currwidth > maxwidth) {
          maxwidth = currwidth;
        }
      }
      colModel.getColumn(i).setMaxWidth(maxwidth);

      colModel.getColumn(i).sizeWidthToFit();

      colModel.getColumn(i).setCellRenderer(new MyTableCellRenderer(
          Align_numColumns, Align_numSeqs, statusBar, probs));
    }

  }

  void DoViewSelectAlignment(float threshold) {
    //view
    partialviewflag = 1;

    //variables used:
    //Align_length: maxlength;
    //Align_numColumns: numColumns;
    selected = new int[Align_length];
    left_selected = new int[Align_length];
    right_selected = new int[Align_length];

    datamodel.setDataVector(temps, new Object[Align_length]);
    namedatamodel.setDataVector(names, new Object[1]);

    jTable1.setModel(datamodel);

    jTable2.setModel(namedatamodel);
    //Get the column model.

    TableColumnModel namecolModel = jTable2.getColumnModel();
    namecolModel.setColumnMargin(0);

    TableColumnModel colModel = jTable1.getColumnModel();
    colModel.setColumnMargin(0);

    //Get the column at index pColumn, and set its preferred width.


    TableColumn tc1 = namecolModel.getColumn(0);
    namecolModel.getColumn(0).setMaxWidth(1000);
    namecolModel.getColumn(0).setMinWidth(1000);

    //save processing time
    //maxnamelength*(jTable2.getFontMetrics(jTable2.getFont()).charWidth('W')));

    tc1.setCellRenderer(new MyNameCellRenderer(Align_numColumns,
                                               Align_numSeqs));

    newlength = 0;

    char valuelookingat;
    int maxwidth = 0, currwidth, i, j;
    for (i = 0; i < Align_length; i++) {

      maxwidth = 0;

      colModel.getColumn(i).setMinWidth(0);
      for (j = 0; j <= Align_numSeqs; j++) {
        valuelookingat = (temps[j][i].toString()).charAt(0);
        currwidth = jTable1.getFontMetrics(jTable1.getFont()).
            charWidth(valuelookingat);
        if (currwidth > maxwidth) {
          maxwidth = currwidth;
        }
      }
      selected[newlength] = 0;

      if (probs[i] >= threshold) {
        selected[newlength++] = i;

        colModel.getColumn(i).setMaxWidth(maxwidth);

        colModel.getColumn(i).sizeWidthToFit();

        colModel.getColumn(i).setCellRenderer(new MyTableCellRenderer(
            Align_numColumns, Align_numSeqs, statusBar, probs));
      }
      else {
        colModel.getColumn(i).setMaxWidth(0);
        colModel.getColumn(i).setPreferredWidth(0);

        //colModel.getColumn(i).setCellRenderer(new MyTableCellRenderer(Align_numColumns, Align_numSeqs, statusBar, probs));
      }

    }

    //prepare the column selection index terrain map

    for (i = 0; i < newlength; i++) {
      //make it circular in nature
      if (i == 0) {
        left_selected[i] = selected[newlength - 1];
        right_selected[i] = selected[i + 1];
      }
      else
      if (i == newlength - 1) {
        right_selected[i] = selected[0];
        left_selected[i] = selected[i - 1];
      }
      else {
        left_selected[i] = selected[i - 1];
        right_selected[i] = selected[i + 1];
      }

    }

  }

  //
  public void jTextField2_actionPerformed(ActionEvent e) {
    GapExt = Float.parseFloat(jGapExt.getText());

  }

  public void jCheckBox1_actionPerformed(ActionEvent e) {
    if (jCheckBox1.getModel().isSelected()) {
      ALIGN_MODE = 1;

      DoUnGap();

      jTable1.revalidate();
      jTable2.revalidate();
      jTable1.repaint();
      jTable2.repaint();

    }

  }

  public void jComboBox1_actionPerformed(ActionEvent e) {
    //System.out.println(jScoreMatrix.getSelectedItem());
    ScoreMatrix = jScoreMatrix.getSelectedItem().toString();

    if (ScoreMatrix.equals("gonnet_160")) {
      jGapOpen.setText("22.0");
      jGapExt.setText("1.0");
      jTemp.setText("5");
    }
    else {
      jGapOpen.setText("4.0");
      jGapExt.setText("0.25");
      jTemp.setText("1");
    }
  }

  public void jTextField1_actionPerformed(ActionEvent e) {
    //System.out.println(jGapOpen.getText());
    GapOpen = Float.parseFloat(jGapOpen.getText());
  }

  public void jTable1_mouseClicked(MouseEvent e) {

    int rowIndex, vColIndex;
    rowIndex = jTable1.getSelectedRow();
    vColIndex = jTable1.getSelectedColumn();

    Object value;

    if (ALIGN_MODE == 1 || nogaps == null) {
      return;
    }
    //System.out.println(rowIndex + "..." + vColIndex + "..." + ALIGN_MODE);
    if (rowIndex != 0) {
      value = jTable2.getValueAt(rowIndex, 0);
    }
    else {
      value = "Posterior Probabilities";
    }
    prev_selectedcolindex = vColIndex;
    statusBar.setText(" Sequence:" + (rowIndex) + " Position:" +
                      (vColIndex + 1) + "|" + nogaps[rowIndex][vColIndex] +
                      "   [" + value + " ]");

  }

  public void viewscore_actionPerformed(ActionEvent e) {
    ProbabilityFrame pframe = new ProbabilityFrame(columnscores);
    pframe.setVisible(true);
  }

  public void jMenuItem5_actionPerformed(ActionEvent e) {
    //view pre computed alignment
    ALIGN_MODE = 0;
    AlignmentChooser dlg = new AlignmentChooser(this, "View Alignment", true);

    Dimension dlgSize = dlg.getPreferredSize();
    Dimension frmSize = getSize();
    Point loc = getLocation();
    dlg.setLocation( (frmSize.width - dlgSize.width) / 2 + loc.x,
                    (frmSize.height - dlgSize.height) / 2 + loc.y);
    dlg.setModal(true);

    dlg.pack();
    dlg.setVisible(true);
    String param1 = System.getProperty("ALLALIGNMENTS");
    String param2 = System.getProperty("SELECTALIGNMENTS");

    if (!param1.equals("")) {
      DoViewEntireAlignment();
    }
    else
    if (!param2.equals("")) {
      DoViewSelectAlignment(Float.parseFloat(param2));
    }

  }

  public void jMenuItem6_actionPerformed(ActionEvent e) {
    //view ungapped alignemnt
    ALIGN_MODE = 1;

    DoUnGap();

    jTable1.revalidate();
    jTable2.revalidate();
    jTable1.repaint();
    jTable2.repaint();

  }

  class Frame1_jMenuItem2_ActionAdapter
      implements ActionListener {
    Frame1 adaptee;

    Frame1_jMenuItem2_ActionAdapter(Frame1 adaptee) {
      this.adaptee = adaptee;
    }

    public void actionPerformed(ActionEvent actionEvent) {
      adaptee.jMenuItem2_actionPerformed(actionEvent);
    }
  }

  class Frame1_jMenuItem1_ActionAdapter
      implements ActionListener {
    Frame1 adaptee;

    Frame1_jMenuItem1_ActionAdapter(Frame1 adaptee) {
      this.adaptee = adaptee;
    }

    public void actionPerformed(ActionEvent actionEvent) {
      adaptee.jMenuItem1_actionPerformed(actionEvent);
    }
  }

  class Frame1_jMenuFileExit_ActionAdapter
      implements ActionListener {
    Frame1 adaptee;

    Frame1_jMenuFileExit_ActionAdapter(Frame1 adaptee) {
      this.adaptee = adaptee;
    }

    public void actionPerformed(ActionEvent actionEvent) {
      adaptee.jMenuFileExit_actionPerformed(actionEvent);
    }
  }

  class Frame1_jMenuHelpAbout_ActionAdapter
      implements ActionListener {
    Frame1 adaptee;

    Frame1_jMenuHelpAbout_ActionAdapter(Frame1 adaptee) {
      this.adaptee = adaptee;
    }

    public void actionPerformed(ActionEvent actionEvent) {
      adaptee.jMenuHelpAbout_actionPerformed(actionEvent);
    }

  }

  class Frame1_jTable1_mouseAdapter
      extends MouseAdapter {
    private Frame1 adaptee;
    Frame1_jTable1_mouseAdapter(Frame1 adaptee) {
      this.adaptee = adaptee;
    }

    public void mouseClicked(MouseEvent e) {
      adaptee.jTable1_mouseClicked(e);
    }
  }

  class Frame1_jTable1_keyAdapter
      extends KeyAdapter {
    private Frame1 adaptee;
    Frame1_jTable1_keyAdapter(Frame1 adaptee) {
      this.adaptee = adaptee;
    }

    public void keyReleased(KeyEvent e) {
      adaptee.jTable1_keyReleased(e);

    }

    public void keyPressed(KeyEvent e) {
      adaptee.jTable1_keyPressed(e);

    }

  }

  class Frame1_jTextField1_actionAdapter
      implements ActionListener {
    private Frame1 adaptee;
    Frame1_jTextField1_actionAdapter(Frame1 adaptee) {
      this.adaptee = adaptee;
    }

    public void actionPerformed(ActionEvent e) {
      adaptee.jTextField1_actionPerformed(e);
    }
  }

  class Frame1_jComboBox1_actionAdapter
      implements ActionListener {
    private Frame1 adaptee;
    Frame1_jComboBox1_actionAdapter(Frame1 adaptee) {
      this.adaptee = adaptee;
    }

    public void actionPerformed(ActionEvent e) {
      adaptee.jComboBox1_actionPerformed(e);
    }
  }

  class Frame1_jCheckBox1_actionAdapter
      implements ActionListener {
    private Frame1 adaptee;
    Frame1_jCheckBox1_actionAdapter(Frame1 adaptee) {
      this.adaptee = adaptee;
    }

    public void actionPerformed(ActionEvent e) {
      adaptee.jCheckBox1_actionPerformed(e);
    }
  }

  class Frame1_jTextField2_actionAdapter
      implements ActionListener {
    private Frame1 adaptee;
    Frame1_jTextField2_actionAdapter(Frame1 adaptee) {
      this.adaptee = adaptee;
    }

    public void actionPerformed(ActionEvent e) {
      adaptee.jTextField2_actionPerformed(e);
    }

  }

//java almanac code
//http://javaalmanac.com/egs/javax.swing.table/CustRend.html
// This renderer extends a component. It is used each time a
// cell must be displayed.
  class MyTableCellRenderer
      extends JLabel implements TableCellRenderer {
    // This method is called each time a cell in a column
    // using this renderer needs to be rendered.
    int numColumns, numSeqs;
    JLabel statusBar;
    float[] probs;

    MyTableCellRenderer(int numcolumns, int numseqs, JLabel jstatusBar,
                        float[] columprob) {

      numColumns = numcolumns;
      numSeqs = numseqs;
      statusBar = jstatusBar;
      probs = columprob;
    }

    public Component getTableCellRendererComponent(JTable table,
        Object value,
        boolean isSelected, boolean hasFocus, int rowIndex,
        int vColIndex) {
      // 'value' is value contained in the cell located at
      // (rowIndex, vColIndex)
      this.setFont(new java.awt.Font("Dialog", java.awt.Font.PLAIN, 10));

      this.setHorizontalAlignment(SwingConstants.CENTER);

      if (isSelected) {
        // cell (and perhaps other cells) are selected
        if (rowIndex <= numSeqs) {
          setBackground(Color.BLACK);
          setForeground(Color.WHITE);
        }
        else {
          setBackground(getBackground());
          setForeground(getForeground());
        }
        //System.out.println("selected");
      }

      if (hasFocus) {
        // this cell is the anchor and the table has the focus
        setBackground(getBackground());
        setForeground(getForeground());

        // System.out.println("focussed:" + rowIndex + "   " + vColIndex);

      }

      // Configure the component with the specified value
      setOpaque(true);

      float tempprobs = probs[vColIndex];

      if (rowIndex <= numSeqs) {
        int colorcategory = 0;
        if (tempprobs < 0.1) {
          colorcategory = 1;
        }
        else if (tempprobs < 0.2) {
          colorcategory = 2;
        }
        else if (tempprobs < 0.3) {
          colorcategory = 3;
        }
        else if (tempprobs < 0.4) {
          colorcategory = 4;
        }
        else if (tempprobs < 0.5) {
          colorcategory = 5;
        }
        else if (tempprobs < 0.6) {
          colorcategory = 6;
        }
        else if (tempprobs < 0.7) {
          colorcategory = 7;
        }
        else if (tempprobs < 0.8) {
          colorcategory = 8;
        }
        else if (tempprobs < 0.9) {
          colorcategory = 9;
        }
        else {
          colorcategory = 10;
        }
        int redvalue = (int) ( (255.0 / 10) * colorcategory);

        if (isSelected) {
          setForeground(getForeground());

          setText(value.toString());

          setBackground(getBackground());
          setToolTipText(Float.toString(probs[vColIndex]));
        }
        else {
          setForeground(Color.black);
          setText(value.toString());

          setBackground(new Color( (float) 1.0, (float) 0.0,
                                  (float) 0.0, probs[vColIndex]));
          //(colorcategory/10.0)));//redvalue, 0, 0));
          setToolTipText(Float.toString(probs[vColIndex]));

        }

      }
      else {
        setBackground(Color.lightGray);
        setForeground(Color.lightGray);

      }

// Since the renderer is a component, return itself
      return this;
    }

  }

//render pdf table

  class MyPdfTableCellRenderer
      extends JLabel implements TableCellRenderer {
    // This method is called each time a cell in a column
    // using this renderer needs to be rendered.
    int numColumns, numSeqs;

    float[] probs;

    MyPdfTableCellRenderer(int numcolumns, int numseqs, float[] columprob) {

      numColumns = numcolumns;
      numSeqs = numseqs;
      probs = columprob;
    }

    public Component getTableCellRendererComponent(JTable table,
        Object value,
        boolean isSelected, boolean hasFocus, int rowIndex,
        int vColIndex) {
      // 'value' is value contained in the cell located at
      // (rowIndex, vColIndex)
      this.setFont(new java.awt.Font("Dialog", java.awt.Font.PLAIN, 10));

      this.setHorizontalAlignment(SwingConstants.CENTER);

      if (isSelected) {

      }

      if (hasFocus) {

      }

      // Configure the component with the specified value
      setOpaque(true);

      float tempprobs = probs[vColIndex];

      if (rowIndex <= numSeqs) {
        int colorcategory = 0;
        if (tempprobs < 0.1) {
          colorcategory = 1;
        }
        else if (tempprobs < 0.2) {
          colorcategory = 2;
        }
        else if (tempprobs < 0.3) {
          colorcategory = 3;
        }
        else if (tempprobs < 0.4) {
          colorcategory = 4;
        }
        else if (tempprobs < 0.5) {
          colorcategory = 5;
        }
        else if (tempprobs < 0.6) {
          colorcategory = 6;
        }
        else if (tempprobs < 0.7) {
          colorcategory = 7;
        }
        else if (tempprobs < 0.8) {
          colorcategory = 8;
        }
        else if (tempprobs < 0.9) {
          colorcategory = 9;
        }
        else {
          colorcategory = 10;
        }
        int redvalue = (int) ( (255.0 / 10) * colorcategory);

        /*
         switch struct kept for color improvement in future
         */
        setForeground(Color.black);
        setText(value.toString());

        if (probs[vColIndex] == 0) {
          setBackground(Color.white);
        }
        else {
          setBackground(new Color( (float) 1.0, (float) 0.0,
                                  (float) 0.0, probs[vColIndex]));
        }

      }
      else {
        setBackground(Color.lightGray);
        setForeground(Color.lightGray);

      }

// Since the renderer is a component, return itself
      return this;
    }

  }

//renderer for table2
  class MyNameCellRenderer
      extends JLabel implements TableCellRenderer {
    // This method is called each time a cell in a column
    // using this renderer needs to be rendered.
    int numColumns, numSeqs;

    MyNameCellRenderer(int numcolumns, int numseqs) {

      numColumns = numcolumns;
      numSeqs = numseqs;
    }

    public Component getTableCellRendererComponent(JTable table,
        Object value,
        boolean isSelected, boolean hasFocus, int rowIndex,
        int vColIndex) {
      // 'value' is value contained in the cell located at
      // (rowIndex, vColIndex)
      this.setFont(new java.awt.Font("Dialog", java.awt.Font.PLAIN, 10));
      this.setHorizontalAlignment(SwingConstants.LEFT);

      if (isSelected) {
        // cell (and perhaps other cells) are selected
        setBackground(getBackground());
        setForeground(getForeground());
      }

      if (hasFocus) {
        // this cell is the anchor and the table has the focus
        setBackground(getBackground());
        setForeground(getForeground());

        // System.out.println("focussed:" + rowIndex + "   " + vColIndex);

      }

      // Configure the component with the specified value
      setOpaque(true);

      if (rowIndex <= numSeqs) {
        setBackground(getBackground());
        setForeground(getForeground());
        setText(value.toString());
      }
      else {
        setBackground(getBackground());
        setForeground(getForeground());
      }

// Since the renderer is a component, return itself
      return this;
    }

  }

  class MyAdjustmentListener1
      implements AdjustmentListener {
    // This method is called whenever the value of a scrollbar is changed,
    // either by the user or programmatically.
    public void adjustmentValueChanged(AdjustmentEvent evt) {
      Adjustable source = evt.getAdjustable();

      // getValueIsAdjusting() returns true if the user is currently
      // dragging the scrollbar's knob and has not picked a final value
      if (evt.getValueIsAdjusting()) {
        jScrollPane2.getVerticalScrollBar().setValue(evt.getValue());
        // The user is dragging the knob
        return;
      }

      // Get current value

      jScrollPane2.getVerticalScrollBar().setValue(evt.getValue());

    }
  }

  class MyAdjustmentListener2
      implements AdjustmentListener {

    // This method is called whenever the value of a scrollbar is changed,
    // either by the user or programmatically.
    public void adjustmentValueChanged(AdjustmentEvent evt) {
      Adjustable source = evt.getAdjustable();

      // getValueIsAdjusting() returns true if the user is currently
      // dragging the scrollbar's knob and has not picked a final value
      if (evt.getValueIsAdjusting()) {
        // The user is dragging the knob
        jScrollPane1.getVerticalScrollBar().setValue(evt.getValue());
        return;
      }

      // Get current value
      jScrollPane1.getVerticalScrollBar().setValue(evt.getValue());
    }
  }

//SAMPLE CODE

  public void tableToImage(Component c, int number) {
    try {
      int width = c.getWidth();
      int height = c.getHeight();
      c.requestFocus();
      BufferedImage image = new BufferedImage(width, height,
                                              BufferedImage.TYPE_INT_ARGB);

      Graphics2D g2device = image.createGraphics();
      c.paint(g2device);
      g2device.dispose();

      ImageIO.write(image, "png",
                    new File(basedir+"/javagui/tempfiles/tableImage.png"));// + number + ".png"));
    }
    catch (Exception e) {
      System.out.println(e);
    }
  }

  public void saveAlignmentToFasta(String savefile) {
    try {
      String line = null;
      PrintWriter out = new PrintWriter(new FileWriter(savefile));

      BufferedReader in = new BufferedReader(new FileReader(
          basedir+"/javagui/tempfiles/align.fasta"));

      while ( (line = in.readLine()) != null) {

        if (line.lastIndexOf(">") != -1) {

          out.println(line);
          continue;

        }

        out.println(line);

      }
      out.close();
      in.close();
    }
    catch (Exception e) {
      System.out.println(e);
    }
  }

  public void pages_to_pdf(String savefile) {

    try {

      Document pdfdoc = new Document(PageSize.A4);
      PdfWriter.getInstance(pdfdoc, new FileOutputStream(savefile));
      pdfdoc.open();
      pdfdoc.add(new Paragraph(
          "Alignment generated by PROBALIGN GUI Beta 1.3\n\nSequence File Name: " +
          filename));
      pdfdoc.newPage();

      Object[][] page = null; //= new Object[Align_numSeqs + 1][42];
      float[] pdf_prob = null; //= new float[42];
      int i, j, i1, j1;

      int column_pages = (int) Math.ceil( (double) Align_numColumns /
                                         58.0);

      JTable pdfTable = new JTable();

      pdfTable.setBackground(Color.white);

      pdfTable.setFont(new java.awt.Font("Dialog", java.awt.Font.PLAIN,
                                         10));

      pdfTable.setBorder(null);
      pdfTable.setIntercellSpacing(new Dimension(0, 0));
      pdfTable.setRowMargin(0);
      pdfTable.setToolTipText("");
      pdfTable.setAutoResizeMode(JTable.AUTO_RESIZE_OFF);
      pdfTable.setGridColor(Color.lightGray);
      pdfTable.setShowHorizontalLines(false);
      pdfTable.setShowVerticalLines(false);
      pdfTable.setSize(new Dimension(700, 700));
      pdfTable.setFont(new java.awt.Font("Dialog", java.awt.Font.PLAIN,
                                         10));

      int old_Vpage_size = 0, old_Hpage_size = 0, Vpage_size = 0,
          Hpage_size = 0;

      int last_column_size = Align_numColumns -
          ( (int) Math.floor( (double) Align_numColumns /
                             58.0)) * 58;

      int vertical_pages = (int) Math.ceil( (Align_numSeqs + 1) / 40.0);

      int last_row_size = Align_numSeqs + 1 -
          ( (int) Math.floor( (Align_numSeqs + 1) / 40.0)) *
          40;

      int horizontal_index = 0, vertical_index = 0;

      int imagenumber = 0;

      for (int horizontal = 0; horizontal < column_pages; horizontal++) {

        vertical_index = 0;
        for (int vertical = 0; vertical < vertical_pages; vertical++) {

          if (horizontal == (column_pages - 1)) { //incomplete page..last one
            Hpage_size = last_column_size + 2;
          }
          else {

            old_Hpage_size = 60;
            Hpage_size = 60;
          }

          if (vertical == (vertical_pages - 1)) {
            Vpage_size = last_row_size;
          }
          else {
            old_Vpage_size = 40;
            Vpage_size = 40;
          }

          page = null;
          pdf_prob = null;
          Runtime.getRuntime().gc();
          page = new Object[Vpage_size][Hpage_size];
          pdf_prob = new float[Hpage_size];

          //System.out.println("@" + Vpage_size);

          for (i = 0; i < Vpage_size; i++) {

            for (j = 0; j < Hpage_size; j++) {
              if (j == 0) {
                pdf_prob[0] = 0;
                page[i][j] = names[vertical * old_Vpage_size +
                    i][0]; //vertical*Vpage_size+i][0];
              }
              else if (j == 1) {
                page[i][j] = new String(" ");
                pdf_prob[1] = 0;
              }
              else {
                page[i][j] = temps[vertical * old_Vpage_size +
                    i][horizontal *
                    (old_Hpage_size - 2) + j - 2];
                //[vertical*Vpage_size + i][horizontal * Hpage_size + j - 1];
                pdf_prob[j] = probs[horizontal *
                    (old_Hpage_size - 2) + j - 2];
                //horizontal * Hpage_size + j - 1];
              }
            }

          }

          vertical_index += Vpage_size;
          DefaultTableModel pdf_datamodel = new DefaultTableModel();
          //put in jtable and send to pdf writer
          pdf_datamodel.setDataVector(page, new Object[Hpage_size]);

          pdfTable.setModel(pdf_datamodel);

          TableColumnModel colModel = pdfTable.getColumnModel();
          colModel.setColumnMargin(0);
          colModel.getColumn(0).setWidth(65);
          colModel.getColumn(1).setWidth(1);
          //Get the column at index pColumn, and set its preferred width.


          char valuelookingat;
          int maxwidth = 0, currwidth;
          for (i1 = 2; i1 < Hpage_size; i1++) {

            maxwidth = 0;
            colModel.getColumn(i1).setMinWidth(0);

            for (j1 = 0; j1 < Vpage_size; j1++) {
              valuelookingat = (page[j1][i1].toString()).charAt(0);
              currwidth = pdfTable.getFontMetrics(pdfTable.
                                                  getFont()).
                  charWidth(valuelookingat);
              if (currwidth > maxwidth) {
                maxwidth = currwidth;
              }
            }
            colModel.getColumn(i1).setMaxWidth(maxwidth);

            colModel.getColumn(i1).sizeWidthToFit();

            colModel.getColumn(i1).setCellRenderer(new
                MyPdfTableCellRenderer(
                    Hpage_size, Vpage_size, pdf_prob));

          }

          tableToImage(pdfTable, imagenumber);
          String header = "            ";
          header += horizontal_index + "\n\n";

          com.lowagie.text.Image screenshot1 = com.lowagie.text.Image.
              getInstance(basedir+"/javagui/tempfiles/tableImage.png");// + imagenumber + ".png");
          imagenumber++;

          pdfdoc.add(new Chunk(header));
          pdfdoc.add(screenshot1);
          pdfdoc.newPage();

        }
        horizontal_index += (Hpage_size - 2);
      }

      pdfdoc.close();

    }
    catch (Exception e) {
      e.printStackTrace();
    }

  }

//print partial pdf
  public void partial_pages_to_pdf(String savefile) {

    try {

      Document pdfdoc = new Document(PageSize.A4);
      PdfWriter.getInstance(pdfdoc, new FileOutputStream(savefile));
      pdfdoc.open();

      pdfdoc.add(new Paragraph(
          "Alignment generated by PROBALIGN GUI Beta 1.3\n\nSequence File Name: " +
          filename));

      pdfdoc.newPage();

      Object[][] page = null; //= new Object[Align_numSeqs + 1][42];
      float[] pdf_prob = null; //= new float[42];
      int i, j, i1, j1;

      int column_pages = (int) Math.ceil( (double) newlength /
                                         58.0);

      JTable pdfTable = new JTable();

      pdfTable.setBackground(Color.white);

      pdfTable.setFont(new java.awt.Font("Dialog", java.awt.Font.PLAIN,
                                         10));

      pdfTable.setBorder(null);
      pdfTable.setIntercellSpacing(new Dimension(0, 0));
      pdfTable.setRowMargin(0);
      pdfTable.setToolTipText("");
      pdfTable.setAutoResizeMode(JTable.AUTO_RESIZE_OFF);
      pdfTable.setGridColor(Color.lightGray);
      pdfTable.setShowHorizontalLines(false);
      pdfTable.setShowVerticalLines(false);
      pdfTable.setSize(new Dimension(700, 700));
      pdfTable.setFont(new java.awt.Font("Dialog", java.awt.Font.PLAIN,
                                         10));

      int old_Vpage_size = 0, old_Hpage_size = 0, Vpage_size = 0,
          Hpage_size = 0;

      int last_column_size = newlength -
          ( (int) Math.floor( (double) newlength /
                             58.0)) * 58;

      int vertical_pages = (int) Math.ceil( (Align_numSeqs + 1) / 40.0);

      int last_row_size = Align_numSeqs + 1 -
          ( (int) Math.floor( (Align_numSeqs + 1) / 40.0)) *
          40;

      int horizontal_index = 0, vertical_index = 0;

      int imagenumber = 0;

      for (int horizontal = 0; horizontal < column_pages; horizontal++) {

        vertical_index = 0;
        for (int vertical = 0; vertical < vertical_pages; vertical++) {

          if (horizontal == (column_pages - 1)) { //incomplete page..last one
            Hpage_size = last_column_size + 2;
          }
          else {

            old_Hpage_size = 60;
            Hpage_size = 60;
          }

          if (vertical == (vertical_pages - 1)) {
            Vpage_size = last_row_size;
          }
          else {
            old_Vpage_size = 40;
            Vpage_size = 40;
          }

          page = null;
          pdf_prob = null;
          Runtime.getRuntime().gc();
          page = new Object[Vpage_size][Hpage_size];
          pdf_prob = new float[Hpage_size];

          //System.out.println("@" + Vpage_size);

          for (i = 0; i < Vpage_size; i++) {

            for (j = 0; j < Hpage_size; j++) {
              if (j == 0) {
                pdf_prob[0] = 0;
                page[i][j] = names[vertical * old_Vpage_size +
                    i][0]; //vertical*Vpage_size+i][0];
              }
              else if (j == 1) {
                page[i][j] = new String(" ");
                pdf_prob[1] = 0;
              }
              else {
                page[i][j] = temps[vertical * old_Vpage_size +
                    i][selected[horizontal *
                    (old_Hpage_size - 2) + j - 2]];
                //[vertical*Vpage_size + i][horizontal * Hpage_size + j - 1];
                pdf_prob[j] = probs[selected[horizontal *
                    (old_Hpage_size - 2) +
                    j - 2]];
                //horizontal * Hpage_size + j - 1];
              }
            }

          }

          vertical_index += Vpage_size;
          DefaultTableModel pdf_datamodel = new DefaultTableModel();
          //put in jtable and send to pdf writer
          pdf_datamodel.setDataVector(page, new Object[Hpage_size]);

          pdfTable.setModel(pdf_datamodel);

          TableColumnModel colModel = pdfTable.getColumnModel();
          colModel.setColumnMargin(0);
          colModel.getColumn(0).setWidth(65);
          //Get the column at index pColumn, and set its preferred width.


          char valuelookingat;
          int maxwidth = 0, currwidth;
          for (i1 = 1; i1 < Hpage_size; i1++) {

            maxwidth = 0;
            colModel.getColumn(i1).setMinWidth(0);

            for (j1 = 0; j1 < Vpage_size; j1++) {
              valuelookingat = (page[j1][i1].toString()).charAt(0);
              currwidth = pdfTable.getFontMetrics(pdfTable.
                                                  getFont()).
                  charWidth(valuelookingat);
              if (currwidth > maxwidth) {
                maxwidth = currwidth;
              }
            }
            colModel.getColumn(i1).setMaxWidth(maxwidth);

            colModel.getColumn(i1).sizeWidthToFit();

            colModel.getColumn(i1).setCellRenderer(new
                MyPdfTableCellRenderer(
                    Hpage_size, Vpage_size, pdf_prob));

          }

          //endjtable

          tableToImage(pdfTable, imagenumber);
          String header = "            ";
          header += horizontal_index + "\n\n";

          com.lowagie.text.Image screenshot1 = com.lowagie.text.Image.
              getInstance(basedir+"/javagui/tempfiles/tableImage.png");// + imagenumber + ".png");
          imagenumber++;

          pdfdoc.add(new Chunk(header));
          pdfdoc.add(screenshot1);
          pdfdoc.newPage();

        }
        horizontal_index += (Hpage_size-2);
      }

      pdfdoc.close();

    }
    catch (Exception e) {
      e.printStackTrace();
    }

  }

  //
  public int prev_selected_index(int presentIndex) {
    int i, value = selected[0];
    for (i = newlength - 1; i >= 0; i--) {
      if (selected[i] < presentIndex) {
        value = selected[i];
        break;
      }
    }

    return value;

  }

  public boolean not_selected(int presentIndex) {
    int i;
    boolean value = true;
    for (i = 0; i <= newlength - 1; i++) {
      if (selected[i] == presentIndex) {
        value = false;
        break;
      }
    }

    return value;
  }

  public int next_selected_index(int presentIndex) {
    int i, value = selected[newlength - 1];
    for (i = 0; i <= newlength - 1; i++) {
      if (selected[i] > presentIndex) {
        value = selected[i];
        break;
      }
    }

    return value;

  }

  public void jTable1_keyPressed(KeyEvent e) {
    return;
  }

  public void jTable1_keyReleased(KeyEvent e) {
    int rowIndex, vColIndex;
    rowIndex = jTable1.getSelectedRow();
    vColIndex = jTable1.getSelectedColumn();

    Object value;

    if (ALIGN_MODE == 1 || nogaps == null) {
      return;
    }

    //System.out.println(rowIndex + "..." + vColIndex + "..." + ALIGN_MODE);

    if (rowIndex != 0) {
      value = jTable2.getValueAt(rowIndex, 0);

    }
    else {
      value = "Posterior Probabilities";
    }

    //if(e.getKeyCode()==e.VK_UP||e.getKeyCode()==e.VK_DOWN||

    if (!not_selected(vColIndex)) {
      prev_selectedcolindex = vColIndex;
    }
    else {

      if (partialviewflag == 1) {
        if (e.getKeyCode() == e.VK_RIGHT) {
          vColIndex = prev_selectedcolindex =
              next_selected_index(vColIndex); //next_selectedcolindex
          jTable1.changeSelection(rowIndex, vColIndex, false, false);
        }
        else if (e.getKeyCode() == e.VK_LEFT) {
          vColIndex = prev_selectedcolindex =
              prev_selected_index(vColIndex); //prev_selectedcolindex
          jTable1.changeSelection(rowIndex, vColIndex, false, false);
        }
      }
    }

    statusBar.setText("Sequence:" + (rowIndex) + " Position:" +
                      (vColIndex + 1) + "|" + nogaps[rowIndex][vColIndex] +
                      "   [" + value + " ]");

  }

  class Frame1_jMenuItem6_actionAdapter
      implements ActionListener {
    private Frame1 adaptee;
    Frame1_jMenuItem6_actionAdapter(Frame1 adaptee) {
      this.adaptee = adaptee;
    }

    public void actionPerformed(ActionEvent e) {
      adaptee.jMenuItem6_actionPerformed(e);
    }
  }

  class Frame1_jMenuItem5_actionAdapter
      implements ActionListener {
    private Frame1 adaptee;
    Frame1_jMenuItem5_actionAdapter(Frame1 adaptee) {
      this.adaptee = adaptee;
    }

    public void actionPerformed(ActionEvent e) {
      adaptee.jMenuItem5_actionPerformed(e);
    }
  }

  public void FileSaveActionForMac(ActionEvent e,String flter) {
    //save action

    FileDialog dlg = new FileDialog(this, "Save As "+flter, FileDialog.SAVE);
    Dimension dlgSize = dlg.getPreferredSize();
    Dimension frmSize = getSize();
    Point loc = getLocation();
    dlg.setLocation( (frmSize.width - dlgSize.width) / 2 + loc.x,
                    (frmSize.height - dlgSize.height) / 2 + loc.y);
    dlg.setModal(true);
    dlg.pack();
    dlg.setVisible(true);

    if (dlg.getDirectory() != null && dlg.getFile() != null) {
      savefile = dlg.getDirectory() + dlg.getFile();
      System.setProperty("SAVEASFILE", savefile);
    }

    //pdf/text saving part

    if (savefile != null && !savefile.equals("")) {

      SwingWorker worker = new SwingWorker() {

        public Object construct() {
          jMenuItem1.setEnabled(false);
          jMenuSaveAsFasta.setEnabled(false);
          jMenuSaveAsPdf.setEnabled(false);
          jMenuItem5.setEnabled(false);
          jMenuItem6.setEnabled(false);
          viewscore.setEnabled(false);

	 statusBar.setIcon(new ImageIcon(basedir+"/javagui/images/a.gif",
                                          "Saving"));
         statusBar.setText(" Saving Alignment to " + savefile);



	  if (savefile.toLowerCase().lastIndexOf(".pdf") != -1) {
            if (partialviewflag == 0) {
              pages_to_pdf(savefile);
            }
            else {
              partial_pages_to_pdf(savefile);
            }
          }
          else {
            saveAlignmentToFasta(savefile);
          }
          return null;
        }

        public void finished() {
          wasSaved = true;
          jMenuItem1.setEnabled(true);
          jMenuSaveAsFasta.setEnabled(true);
          jMenuSaveAsPdf.setEnabled(true);
          jMenuItem5.setEnabled(true);
          jMenuItem6.setEnabled(true);
          viewscore.setEnabled(true);
          statusBar.setIcon(null);
	  statusBar.setText(" Saved Alignment to " + savefile);
        }

      };

      worker.start();

    }

  }

  class Frame1_viewscore_actionAdapter
      implements ActionListener {
    private Frame1 adaptee;
    Frame1_viewscore_actionAdapter(Frame1 adaptee) {
      this.adaptee = adaptee;
    }

    public void actionPerformed(ActionEvent e) {
      adaptee.viewscore_actionPerformed(e);
    }
  }

  class Frame1_jMenuSaveAsPdf_actionAdapter
      implements ActionListener {
    private Frame1 adaptee;
    Frame1_jMenuSaveAsPdf_actionAdapter(Frame1 adaptee) {
      this.adaptee = adaptee;
    }

    public void actionPerformed(ActionEvent e) {
      adaptee.jMenuSaveAsPdf_actionPerformed(e);
    }
  }

  class Frame1_jMenuSaveAsFasta_actionAdapter
      implements ActionListener {
    private Frame1 adaptee;
    Frame1_jMenuSaveAsFasta_actionAdapter(Frame1 adaptee) {
      this.adaptee = adaptee;
    }

    public void actionPerformed(ActionEvent e) {
      adaptee.jMenuSaveAsFasta_actionPerformed(e);
    }
  }


}
