package probalign;

import java.awt.*;

import javax.swing.*;
import javax.swing.table.DefaultTableModel;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

/**
 * <p>Title: Probability Frame</p>
 *
 * <p>Description: displays the probabilities of the alignment columns</p>
 *
 *
 * @author Satish Chikkagoudar
 * @version Beta 1.3
 */
public class ProbabilityFrame extends JFrame {
    BorderLayout borderLayout1 = new BorderLayout();
    JScrollPane jScrollPane1 = new JScrollPane();
    JTable jTable1 = new JTable();

    DefaultTableModel datamodel = new DefaultTableModel();
    Object[][] columnscores = null;
    JPanel jPanel1 = new JPanel();
    Box box1 = Box.createHorizontalBox();
    Box box2 = Box.createHorizontalBox();
    Box box3 = Box.createHorizontalBox();
    JButton jButton1 = new JButton();
    public ProbabilityFrame(Object[][] scores) {
        try {

            columnscores = scores;
            jbInit();
        } catch (Exception exception) {
            exception.printStackTrace();
        }
    }

    private void jbInit() throws Exception {
        box3 = Box.createHorizontalBox();
        box2 = Box.createHorizontalBox();
        box1 = Box.createHorizontalBox();
        getContentPane().setLayout(borderLayout1);
        this.setCursor(null);
         this.setResizable(true); //false);

         setSize(new Dimension(500, 500));

        this.setTitle("Posterior Probabilities of Columns");
        jButton1.setText("Close");
        jButton1.addActionListener(new ProbabilityFrame_jButton1_actionAdapter(this));
        jScrollPane1.getViewport().add(jTable1);
        this.getContentPane().add(jScrollPane1, java.awt.BorderLayout.CENTER);
        this.getContentPane().add(jPanel1, java.awt.BorderLayout.SOUTH);
        jPanel1.add(box3);
        jPanel1.add(box2);
        jPanel1.add(box1);
        box1.add(jButton1);
        String[] header = {"Column Number", "Probability"};

        datamodel.setDataVector(columnscores, header);

        jTable1.setModel(datamodel);



    }

    public void jButton1_actionPerformed(ActionEvent e) {
       dispose();
    }
}


class ProbabilityFrame_jButton1_actionAdapter implements ActionListener {
    private ProbabilityFrame adaptee;
    ProbabilityFrame_jButton1_actionAdapter(ProbabilityFrame adaptee) {
        this.adaptee = adaptee;
    }

    public void actionPerformed(ActionEvent e) {
        adaptee.jButton1_actionPerformed(e);
    }
}
